﻿using Avalonia.Controls;
using AvaloniaApplicationPersonalPage.Models;
using AvaloniaApplicationPersonalPage.Views;
using ReactiveUI;
using System.Linq;

namespace AvaloniaApplicationPersonalPage.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
       public static UserBaseContext myConnection = new UserBaseContext(); // создаем объект для обращения к БД

        UserControl uc = new AutoPage();  // для смены страниц, страница с авторизацией будет загружена по умолчанию
        AutoPageViewModel autoPage = new AutoPageViewModel(); // для обращения к свойсвам, которые находятся на странице авторизации
        PersonalPageViewModel personalPage; // для обращения к свойствам, которые находятся на стпранице личного кабинета (будет инициализировано позднее, в момент перехода на данную страницу)

        public UserControl UC { get => uc; set => this.RaiseAndSetIfChanged(ref uc,value); } // свойство для обращения к полю для смены страниц
        public AutoPageViewModel AutoPage { get => autoPage; set => autoPage = value; } // свойство для обращения к полю для обращения к странице авторизации
        public PersonalPageViewModel PersonalPage { get => personalPage; set => personalPage = value; } // свойство для обращения к полю для обращения к странице личного кабинета

        public void Auto() // метод для авторизации
        {
            // ищем в БД пользователя по введенному логину и паролю
            LoginTable? currentUser = myConnection.LoginTables.FirstOrDefault(x => x.Login == AutoPage.Login && x.Password == AutoPage.Password);
            if (currentUser == null)
            {
                AutoPage.Message = "Пользователь не найден";
                return;
            }
            // если пользователь найден, то переходим на страницу личного кабинета
            // в конструктор этой страницы передаем объект для обращения к БД и id найденного пользователя
            personalPage = new PersonalPageViewModel(myConnection, currentUser.IdLogin);
            UC = new PersonalPage();
        }
    }
}