using System;
using System.Collections.Generic;
using System.Linq;
using AvaloniaApplicationPersonalPage.Models;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;

namespace AvaloniaApplicationPersonalPage.ViewModels
{
	public class PersonalPageViewModel : ReactiveObject
	{
        UserBaseContext myConnection; //        
        LoginTable? currentUser; //      
        string oldPassword; //    
        bool isPasswordChange = false; //        (   )

        public PersonalPageViewModel(UserBaseContext myConnection, int id)
        {
            this.myConnection = myConnection; //      
            //        id:
            CurrentUser = myConnection.LoginTables.Include(x=>x.IdRoleNavigation).Include(x=>x.UserTable.IdGenderNavigation).FirstOrDefault(x => x.IdLogin == id);
            oldPassword = currentUser.Password; //       
        }

        public LoginTable? CurrentUser { get => currentUser; set => currentUser = value; } //         


        //           ,    
        public string DR
        {
            get => CurrentUser.UserTable.Date.ToString(); //    
            set => CurrentUser.UserTable.Date = DateTime.Parse(value); //         
        }
        public List<string> Genders =>myConnection.GenderTables.Select(x=>x.Gender).ToList(); //        


        //          
        public string SelectedGender
        {
            get => CurrentUser.UserTable.IdGenderNavigation.Gender; //    
            set => CurrentUser.UserTable.IdGender = myConnection.GenderTables.FirstOrDefault(x => x.Gender == value).IdGender; //        
        }
        public string Message { get => message; set => this.RaiseAndSetIfChanged(ref message,value); }  //      
        public string RepeatPassword { get => repeatPassword; set => repeatPassword = value; } // ,       
        public bool IsPasswordChange { get => isPasswordChange; set => this.RaiseAndSetIfChanged(ref isPasswordChange,value); } // ,   ,  (  )    

        string message; //   

        string repeatPassword; //   
       

        public void SaveData() //    
        {
            if (CurrentUser.Password == null || CurrentUser.Password == "") CurrentUser.Password = oldPassword; //       ,      
            if (IsPasswordChange==(CurrentUser.Password == repeatPassword)) 
            {
            myConnection.SaveChanges();
            Message = " ";
            }
            else
            {
                Message = "  ";
            }
            
        }
    }
}